package ctree;

/**
 * A class holding user-defined function for computing contradiction.
 * This function is the same as in {@link main.CValues} and used for DB2 database testing.
 *
 * @author Mikalai Tsytsarau;
 */

import java.sql.SQLException;
import COM.ibm.db2.app.UDF; // UDF classes

// Java user-defined functions are in this class
public class CFunction extends UDF {

    public static float[] weights = new float[]{1.0049453f, 1.0359724f, 1.2384058f, 2.0f, 2.7615943f, 2.9640276f, 2.9950547f, 2.9993293f, 2.9999092f, 2.9999876f};

    public static float contradict(int n, float m1, float m2) throws SQLException {
        float wt;
        float st;
        float vt;
        float ct;
        int nn = n / 10;
        if (nn < 10) {
            wt = weights[nn];
        } else {
            wt = 3f;
        }
        st = m1 / n;
        float st2 = st * st;
        vt = m2 / n - st2;
        vt = vt > 0f ? vt : 0f;

        ct = vt * wt / (0.05f + st2);
        // set the output value
        return ct;
    }
}



