package ctree;

/**
 * An interface for managing CTree and retrieving contradictions.
 * It can retrieve contradiction values from a CTree.
 *
 * @author Mikalai Tsytsarau;
 */

import main.CValues;

import java.util.List;

public interface Model {
    public List<CValues> getContradictions(int topicId, int begin, int end, int height, float threshold, boolean isRecursive);
    public List<CValues> getContradictionsTopK(int topicId, int begin, int end, int height, int k);
    public List<CValues> getContradictingTopics(int begin, int end, int height, float threshold, boolean isRecursive, int limit);
    public List<CValues> getContradictingTopicsTopK(int begin, int end, int height, int k);
}
