package test;

/**
 * A class for bulk-testing {@link ctree.CIndex} and database implementations of a CTree.
 *
 * @author Mikalai Tsytsarau;
 */

import ctree.CModel;
import ctree.DBModel;
import main.*;

import ui.EvaluationManager;


public class TestCIndex {
    CModel model;
    DBModel dbModel;

    private java.util.List<CValues> topics = null;


    EvaluationManager em;

    public TestCIndex(EvaluationManager em, CModel model) {
        this.em = em;
        this.model = model;
    }

    public void TestAll(EvaluationManager em) {
        int[] types = new int[]{1, 2};
        boolean[] opts = new boolean[]{false, true};
        int[] limits = new int[]{0, 1, 2, 3, 4};

        for (int type : types) {
            for (boolean opt1 : opts) {
                for (boolean opt2 : opts) {
                    em.testTimeInterval(type, opt1, opt2);
                }
            }
        }

        for (int type : types) {
            for (boolean opt1 : opts) {
                for (boolean opt2 : opts) {
                    for (int lim : limits) {
                        em.testGranularity(type, opt1, opt2, lim);
                    }
                }
            }
        }

    }

    public void smokeTest() {

        System.out.println("----------------------------");
        topics = model.getContradictingTopicsTopK(model.indexBegin, model.indexEnd, 1, 10);
        for (int i = 0; i < topics.size(); i++) {
            System.out.println(i + "\t" + topics.get(i));
        }
        System.out.println("----------------------------");
        topics = dbModel.getContradictingTopicsTopK(model.indexBegin, model.indexEnd, 1, 10);
        for (int i = 0; i < topics.size(); i++) {
            System.out.println(i + "\t" + topics.get(i));
        }

        System.out.println("----------------------------");
        topics = dbModel.getContradictionsTopK(113, model.indexBegin, model.indexEnd, 1, 10);
        for (int i = 0; i < topics.size(); i++) {
            System.out.println(topics.get(i));
        }
        System.out.println("----------------------------");
        topics = model.getContradictionsTopK(113, model.indexBegin, model.indexEnd, 1, 10);
        for (int i = 0; i < topics.size(); i++) {
            System.out.println(topics.get(i));
        }

    }
}