package ui;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;

public class PropertiesManager {
    public static final String MAIN = "main";
    public static final String INDEX = "index";
    public static final String DB = "db";
    public static final String[] props_names = {MAIN, INDEX, DB};
    //The path to config dir
    public static String CONFIG_PATH = "." + File.separator + "config" + File.separator;
    //he path to output dir
    public static String OUTPUT_PATH = "." + File.separator + "out" + File.separator;

    private ArrayList<java.util.Properties> props = new ArrayList<java.util.Properties>();

    public static java.util.Properties loadProperties(String filename) throws IOException {
        return loadProperties(new java.util.Properties(), filename);
    }

    public static java.util.Properties loadProperties(java.util.Properties properties, String filename) throws IOException {
        FileInputStream file = new FileInputStream(filename);
        properties.load(file);
        file.close();
        return properties;
    }

    public void load() {
        FileInputStream input;
        java.util.Properties prop;

        for (String name : props_names) {
            try {
                if (name.equalsIgnoreCase(INDEX)) {
                    input = new FileInputStream(CONFIG_PATH + getProperty(MAIN, "index") + ".properties");
                } else {
                    input = new FileInputStream(CONFIG_PATH + name + ".properties");
                }
                prop = new java.util.Properties();
                prop.load(input);
                props.add(prop);
                input.close();
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
    }

    public String getProperty(String index, String property) {
        return getProperties(index).getProperty(property);
    }

    public String getProperty(String index, String property, String def) {
        return getProperties(index).getProperty(property, def);
    }

    public java.util.Properties getProperties(String index) {
        return props.get(indexOf(index));
    }

    public String putProperty(String index, String property, String value) {
        try {
            getProperties(index).put(property, value);
        } catch (Exception e) {
            return "";
        }
        return (String) getProperties(index).put(property, value);
    }

    public void store() {
        FileOutputStream output = null;
        for (int i = 0; i < props.size(); i++) {
            try {
                String name = props_names[i];
                if (name.equalsIgnoreCase(INDEX)) {
                    output = new FileOutputStream(CONFIG_PATH + getProperty(MAIN, "index") + ".properties");
                } else {
                    output = new FileOutputStream(CONFIG_PATH + name + ".properties");
                }
                props.get(i).store(output, name + " properties");
                output.close();
            } catch (IOException exc) {
                System.err.println("Configuration writing error.");
            }
        }
    }



    private int indexOf(String name) {
        for (int i = 0; i < props_names.length; i++) {
            if (props_names[i].equalsIgnoreCase(name)) return i;
        }
        return -1;
    }

}
